var _seed=0.322
function urandom(seed)
{
    if (!seed)seed=_seed+gameTime/1000/60
    for (var i=0;i<10;i++)seed=(seed*569*Math.PI)%1
    _seed=seed
    return seed
}
function ng(x)
{return (x-0.5)*2}
function nearBy(droid,d=20,playerFilter=me,droidOnly=true)
{
    if (droid===undefined)return []
    var objects=enumRange(droid.x, droid.y, d, playerFilter)
    if (droidOnly)objects=objects.filter((object)=>((object.type==DROID)))
    return objects
}
function choose(x=[],seed=undefined)
{
    return x[parseInt(urandom()*x.length)]
}
function spamBuild(droid,Struct="A0PowerGenerator",maxBlockingTiles,spamScale=0)
{
    var pos=pickStructLocation(droid,Struct,droid.x,droid.y,maxBlockingTiles)
    if (!droidCanReach(droid,pos.x,pos.y))return
    return orderDroidBuild(droid, DORDER_BUILD, Struct, pos.x+spamScale*ng(urandom()), pos.y+spamScale*ng(urandom()))
}
function needRepair(droid)
{
    return droid.health<60
}
function distBetween(a,b)
{
    return distBetweenTwoPoints(a.x,a.y,b.x,b.y)
}

function goodEnemy(object)
{
    if (object.type==STRUCTURE)
    {
        switch (object.stattype) {
            case FACTORY:
            case RESEARCH_LAB:  
                return -1000
            case CYBORG_FACTORY:
                return -500
            case POWER_GEN:
                return -200        
            case OIL_RESOURCE:
                return -100
            default:
                return -object.cost
        }
    }
    if (object.type==DROID)
    {
        return -object.cost
    }
    return 0
}

function goodResearch(x="")
{
    if (!componentAvailable(undefined,"Cannon1Mk1") & (x.startsWith("R-Wpn-MG")))return -10
    if (x.startsWith("R-Sys-Sensor-T"))return -10
    if (x.startsWith("R-Vehicle-Engine01"))return -10
    if (x.startsWith("R-Sys-Autorepair-General"))return -10
    if (x.startsWith("R-Struc-Research-Upgrade"))return -10
    if (x.startsWith("R-Vehicle-Prop-Halftrack"))return -10
    if (x.startsWith("R-Struc-RepairFacility"))return -10
    if (x.startsWith("R-Wpn-Rail"))return -10
    if (x.startsWith("R-Vehicle-Prop-Halftrack"))return 10

    if (x.startsWith("R-Struc-Power"))return -1+x.endsWith("b")*2+x.endsWith("c")*2
    if (x.startsWith("R-Struc-Factory"))return 2-playerPower(me)/2500//+enumDroid(me).length/100

    if (x.startsWith("R-Vehicle-Body"))return 0.5+(!(x.includes("1")|x.includes("5")))//|x.includes("2")|x.includes("6")|x.includes("9")
    if (x.startsWith("R-Wpn-Cannon-"))return 0.4+x.includes("Accuracy")*0.2+getResearch("R-Wpn-RailGun01").done
    if (x.startsWith("R-Wpn-Cannon"))return 0.5+x.endsWith("Cannon5")*2

    if (x.startsWith("R-Vehicle-Metals"))return .8
    if (x.startsWith("R-Cyborg-Metals"))return .9
    if (x.startsWith("R-Cyborg-Hvywpn"))return .8

    if (x.startsWith("R-Struc-RprFac-Upgrade"))return 2-(enumDroid(me).filter(needRepair).length/30)
    if (x.startsWith("R-Sys-Sensor-Upgrade"))return 1-x.endsWith("01")

    if (x.startsWith("R-Sys"))return Math.max(1,2-playerPower(me)/10000)

    if (x.startsWith("R-Struc"))return 2
    if (x.startsWith("R-Vehicle"))return 2
    return 6
}

function pickHome()
{
    if (enumDroid(me).length<135)return startPositions[me]
    var enemy=startPositions.map((x,i)=>(i)).filter(i=>!allianceExistsBetween(me,i)).sort((a,b)=>(enumDroid(b).length-enumDroid(a).length))[0]
    return startPositions[enemy]
    //return pickEnemy(enumDroid(enemy)[0])
}

function pickEnemy(droid)
{
    var em=enumRange(droid.x,droid.y,20,ENEMIES)
    if (em.length>0)return em.sort((a,b)=>goodEnemy(a)-goodEnemy(b))[0]
    return undefined
}

var _fireLassat=0
function fireLassat(target)
{
    var lassats=enumStruct(me,"A0LasSatCommand")
    if (lassats.length==0)return
    if ((gameTime-_fireLassat)/1000<5)return
    activateStructure(lassats[0],target)
    _fireLassat=gameTime
}

function supportDroid(victim, attacker)
{
  

    if (attacker===undefined)return
    if (attacker.health<=1)return
    //if (isVTOL(attacker))return

    var u=urandom()
    var v=urandom()
    var droids=nearBy(victim,3)
    var droids2=nearBy(victim,10).filter((droid)=>!needRepair(droid)).filter((droid)=>droid.stattype!=DROID_CONSTRUCT)
    var droids3=nearBy(attacker,10,ENEMIES,false)

    if (droids3.length>10)fireLassat(pickEnemy(attacker))
    if (droids3.length>droids2.length*1.2)droids.forEach((droid)=>{orderDroid(droid,DORDER_RTB)})
    
    if (droids3.length>20 | (startPositions.length==2 & enumDroid(me).length>120))var droids=enumDroid(me)
    else var droids=nearBy(victim,20)

    droids.filter(droid=>droid.droidType!=DROID_CONSTRUCT).filter(droid=>droid.order!=DORDER_RTR & droid.order!=DORDER_RECYCLE).forEach((droid,i)=>{
        if (needRepair(droid)){orderDroid(droid,DORDER_RTR);return}
        if (droid.stattype==DROID_SENSOR){orderDroidObj(droid,DORDER_OBSERVE,attacker);return}
        if ((i%2 | droid.stattype!=DROID_CYBORG) & droids3.length>droids2.length*0.5)orderDroidObj(droid,DORDER_ATTACK,attacker)
        else orderDroidLoc(droid,DORDER_MOVE,attacker.x+ng(u)*3,attacker.y+ng(v)*3)
    })
}










function zStruct()
{
    var factory=enumStruct(me,FACTORY)
    var cyborg_factory=enumStruct(me,CYBORG_FACTORY)
    var lab=enumStruct(me,RESEARCH_LAB)

    lab.filter(structureIdle).forEach(wResearch)
    if (playerPower(me)<100)return
    cyborg_factory.filter(structureIdle).forEach(wProduct2)
    if (playerPower(me)<300)return
    factory.filter(structureIdle).forEach(wProduct) 

}
function zDroid()
{   
    var droids=enumDroid(me)//.filter(x=>urandom(x.id+gameTime)<0.2)
    var tobuilds=enumStruct(me).filter(x=>x.status==BEING_BUILT)
    var trucks=droids.filter(droid=>droid.droidType==DROID_CONSTRUCT)
    var weapons=droids.filter(droid=>droid.droidType!=DROID_CONSTRUCT)
    var sensors=droids.filter(droid=>droid.droidType==DROID_SENSOR)
    var home=pickHome()

    var u=urandom()
    var v=urandom() 

    trucks.sort((a,b)=>a.id-b.id).filter(truck=>truck.order!=DORDER_BUILD).forEach((truck,i)=>{
        if (tobuilds.length>0)
        {
            orderDroidObj(truck,DORDER_HELPBUILD,choose(tobuilds))
            return
        }
        if (i==0)if (isStructureAvailable("A0CyborgFactory",me))spamBuild(truck,"A0CyborgFactory")    
        if (i==1)if (isStructureAvailable("A0RepairCentre3",me))spamBuild(truck,"A0RepairCentre3")
        if (i==2)if (isStructureAvailable("A0LasSatCommand",me))spamBuild(truck,"A0LasSatCommand")      
        if (i==3)
        {
            if (playerPower(me)-queuedPower(me)<750)return
            
            var defense0=choose([
                ["Emplacement-HvART-pit","Emplacement-Rocket06-IDF","PillBox5"],
                ["Emplacement-Howitzer150","Emplacement-Howitzer105","Emplacement-RotMor","Emplacement-MortarPit01","PillBox1"],
                ["WallTower-SamSite","P0-AASite-Sunburst","PillBox5"],
                ["Sys-SensoTowerWS","Sys-SensoTower02","Sys-SensoTower01"]
            ])
            for (const i in defense0)
                if (isStructureAvailable(defense0[i],me))
                    {   
                        spamBuild(truck,defense0[i],0,8)
                        return
                    }
        }
        if (i>3)return
        orderDroidLoc(truck,DORDER_MOVE,truck.x+ng(u)*10,truck.y+ng(v)*10)
    })
    orderDroidLoc(sensors[0],DORDER_MOVE,home.x+ng(u)*20,home.y+ng(v)*20)
    
    weapons.forEach((weapon)=>{
        u=urandom()
        v=urandom()
        if (((gameTime*2/3))>(weapon.born) & droids.length>145 & nearBy(weapon,3).length<3)
            {
                orderDroid(weapon,DORDER_RECYCLE)
                return
            }
        if (needRepair(weapon))
            {
                orderDroid(weapon,DORDER_RTR)
                return
            }
            
        if (u<0.1)
        {
            u=urandom()
            v=urandom()
            var enemy=pickEnemy(weapon)
            supportDroid(weapon,enemy)
            orderDroidLoc(weapon,DORDER_MOVE,weapon.x+ng(u)*10,weapon.y+ng(v)*10)
        }
    })
}





function wResearch(lab)
{
    var research=enumResearch().sort((a,b)=>goodResearch(a.id)-goodResearch(b.id))
    if (research.length==0)return
    pursueResearch(lab,research[0].id)
}

function wProduct(factory)
{
    var _wTemplate=[
        ["Body14SUP","Body13SUP","Body10MBT","Body9REC","Body12SUP","Body11ABT","Body6SUPP","Body8MBT","Body5REC","Body3MBT","Body2SUP","Body4ABT","Body1REC"],
        ["tracked01",'HalfTrack','wheeled01'],
        0,
        0]
    var w=["RailGun3Mk1","RailGun2Mk1",'RailGun1Mk1',"Cannon6TwinAslt",'Cannon375mmMk1',"Cannon5VulcanMk1","Cannon2A-TMk1","Cannon1Mk1","MG1Mk1"]
    if (componentAvailable(undefined,"V-Tol"))
    {var w=choose([["Missile-HvySAM","Missile-LtSAM","Rocket-Sunburst",...w],w])}
    if (gameTime/1000<200)
    {var w=choose([["MG5TWINROTARY","MG4ROTARYMk1","MG3Mk1","MG2Mk1"],["Flame2","Flame1Mk1"],w])}
    var h="RailGun3Mk1"

    if (countDroid(DROID_CONSTRUCT,me)<5)w="Spade1Mk1"
    if (enumDroid(me,DROID_SENSOR).length<3)w="SensorTurret1Mk1"
    
    buildDroid(factory,"tank",..._wTemplate,w,h)
}
function wProduct2(factory)
{
    if (componentAvailable(0,"Cyb-Hvywpn-RailGunner"))
    {buildDroid(factory,"cyborg","CyborgHeavyBody",'CyborgLegs',0,0,"Cyb-Hvywpn-RailGunner");return}
    if (componentAvailable(0,"Cyb-Wpn-Rail1"))
    {buildDroid(factory,"cyborg","CyborgLightBody",'CyborgLegs',0,0,"Cyb-Wpn-Rail1");return}
    if (componentAvailable(0,"Cyb-Hvywpn-Mcannon"))
    {buildDroid(factory,"cyborg","CyborgHeavyBody",'CyborgLegs',0,0,"Cyb-Hvywpn-Mcannon");return}
    buildDroid(factory,"cyborg","CyborgLightBody",'CyborgLegs',0,0,'CyborgCannon')
}


function eventStartLevel() 
{
    setTimer("zStruct", 1200+me*3);
    setTimer("zDroid", 1000+me*3); 
}
function eventAttacked(victim, attacker)
{
    if (allianceExistsBetween(me,attacker.player))return
    if (victim.type==DROID)orderDroid(victim,DORDER_RTB)
    supportDroid(victim,attacker)
}
